"""
Модуль для парсинга перевода с помощью онлайн-переводчика
Deep_L. Получает тест, запускает браузер, парсит перевод
и возвращает его из функции.
"""

import os.path
from platform import system
from time import sleep

from bs4 import BeautifulSoup
from selenium import webdriver
from selenium.webdriver.common.by import By
from selenium.webdriver.firefox.options import Options
from selenium.webdriver.firefox.service import Service


def browser_get_html(path_text):
    """
    Принимает текст для перевода. Устанавливает опции
    браузера в безголовый режим, создает экземпляр класса
    Firefox. Определяет, какая операционная система у пользователя
    в данный момент. В зависимости от этого подгружает нужный
    веб-драйвер.
    Переходи по ссылке, ищет поле для перевода, вставляет текст,
    ждет 10 секунд для получения полного перевода. Забирает код со
    страницы браузера, парсит перевод, закрывает браузер.
    :param path_text: Текст для перевода.
    :return: Возвращает переведенный текст.
    """
    options = Options()
    options.headless = True
    browser = None

    if system() == "Windows":
        browser = webdriver.Firefox(options=options, service=Service(log_path=os.devnull,
                                                                     executable_path=os.path.join(os.getcwd(),
                                                                                                  'geckodriver',
                                                                                                  'geckodriver.exe')))
    elif system() == "Linux":
        browser = webdriver.Firefox(options=options, service=Service(log_path=os.devnull,
                                                                     executable_path=os.path.join(os.getcwd(),
                                                                                                  'geckodriver',
                                                                                                  'geckodriver')))

    browser.get('https://www.deepl.com/translator')
    sleep(2)
    field = browser.find_element(By.XPATH, '//*[@id="panelTranslateText"]/div[2]/section[1]/div[3]/div[2]/textarea')
    field.send_keys(path_text.strip())

    sleep(10)
    html = browser.page_source
    soup = BeautifulSoup(html, 'lxml')
    translation = soup.find('div', id='target-dummydiv')

    browser.close()
    browser.quit()

    return translation.text




